<?php
require_once('DataObjectBase.class.php');

/**
 * TransactionResultData クラス
 */
class TransactionResultData extends DataObjectBase
{
	const UNKNOWN				= -1;
	const APPROVED				= 0;
	const INVALID_MERCHANTID	= 1;
	const INVALID_MERCHANTPW	= 2;
	const INVALID_CRDNUM		= 3;
	const INVALID_CRDEXP		= 4;
	const INVALID_FIRSTNAME		= 5;
	const INVALID_LASTNAME		= 6;
	const INVALID_AMOUNT		= 7;
	const INVALID_CURRENCY		= 8;
	const INVALID_ORIGID		= 9;
	const INVALID_PAYMENTTYPE	= 10;

	const SUBMIT_EXECUTE_FAILED			= 101;
	const USER_AUTHENTICATION_FAILED	= 102;
	const TRANSACTIONID_NOTFOUND		= 103;

	/**
	 * 既定メンバーの名前のリスト
	 */
	protected $_propertynames = array(
		'RESULT'	=> 'RESULT',
		'PNREF'		=> 'PNREF',
		'RESPMSG'	=> 'RESPMSG',
	);

	/**
	 * コンストラクタ
	 *
	 * @param array $datas メンバー名=>値 形式の連想配列
	 */
	public function __construct($datas = array())
	{
		parent::__construct($datas);
	}
	/**
	 * プロパティリストからデータメンバーを初期化します
	 *
	 * @return void
	 */
	public function emptyObject()
	{
		parent::emptyObject();
		//
		$this->RESULT = self::UNKNOWN;
	}
	/**
	 * RESULT をセットします。
	 *
	 * @param enum $code リザルトコード
	 */
	public function setResultCode($code)
	{
		$this->RESULT = $code;
	}
}

/* End of file */