<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/PaymentControllerBase.abstract.php');

/**
 * Delayed_captur コントローラー
 */
class Delayed_captur extends PaymentControllerBase
{
	/**
	 * コンストラクタ
	 */
	public function __construct()
	{
		parent::__construct();
	}
	/**
	 * index アクション
	 */
	public function index()
	{
		$this->_execTransaction();
	}
	/**
	 * _execTransaction から呼び出されるコールバック。<br/>
	 * PaymentDriver の適切なメソッドをコールするよう実装します。<br/>
	 *
	 * @param PaymentDriver $paydrv PaymentDriver のインスタンス
	 * @param DataObject $obj_req リクエストデータオブジェクト
	 * @return bool 成功時は true
	 */
	protected function _onSubmit(&$paydrv, &$obj_req)
	{
		return $paydrv->transactionDelayedCapture($obj_req);
	}
	/**
	 * 使用する HttpRequestParserModel の名前を返すよう実装します。
	 *
	 * @return string 'models/transaction/' 配下のモデル名
	 */
	protected function _getHttpRequestParserModelName()
	{
		return 'TransidTransactionModel';
	}
}

/* End of file */