<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/PaymentControllerBase.abstract.php');

/**
 * Sale コントローラー
 */
class Sale extends PaymentControllerBase
{
	/**
	 * コンストラクタ
	 */
	public function __construct()
	{
		parent::__construct();
	}
	/**
	 * index アクション
	 */
	public function index()
	{
		$this->_execTransaction();
	}
	/**
	 * _execTransaction から呼び出されるコールバック。<br/>
	 * PaymentDriver の適切なメソッドをコールするよう実装します。<br/>
	 *
	 * @param PaymentDriver $paydrv PaymentDriver のインスタンス
	 * @param DataObject $obj_req リクエストデータオブジェクト
	 * @return bool 成功時は true
	 */
	protected function _onSubmit(&$paydrv, &$obj_req)
	{
		$res = false;
		//
		switch(strtoupper($obj_req->PAYMENTTYPE))
		{
			case 'SALE':
				$res = $paydrv->transactionSale($obj_req);
				break;
			case 'AUTH':
				$res = $paydrv->transactionAuthorization($obj_req);
				break;
			default:
				throw new InvalidArgumentException();
		}
		//
		return $res;
	}
	/**
	 * 使用する HttpRequestParserModel の名前を返すよう実装します。
	 *
	 * @return string 'models/transaction/' 配下のモデル名
	 */
	protected function _getHttpRequestParserModelName()
	{
		return 'SaleTransactionModel';
	}
}

/* End of file */