<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/PaymentControllerBase.abstract.php');

/**
 *
 */
class Void extends PaymentControllerBase
{
	/**
	 * コンストラクタ
	 */
	public function __construct()
	{
		parent::__construct();
	}
	/**
	 * index アクション
	 */
	public function index()
	{
		$this->_execTransaction();
	}
	/**
	 * _execTransaction から呼び出されるコールバック。<br/>
	 * PaymentDriver の適切なメソッドをコールするよう実装します。<br/>
	 *
	 * @param PaymentDriver $paydrv PaymentDriver のインスタンス
	 * @param DataObject $obj_req リクエストデータオブジェクト
	 * @return bool 成功時は true
	 */
	protected function _onSubmit(&$paydrv, &$obj_req)
	{
		$res = false;
		// void 可能か確認
		$dovoid = $paydrv->isAvailableVoid($obj_req);
		$docredit = !$dovoid;
		// void 実行
		if($dovoid)
		{
			$res = $paydrv->transactionVoid($obj_req);
			$docredit = !$paydrv->isTransactionSucceed();	// 失敗したら credit も実行
		}
		// credit 実行
		if($docredit)
			$res = $paydrv->transactionCredit($obj_req);
		// 復帰
		return $res;
	}
	/**
	 * 使用する HttpRequestParserModel の名前を返すよう実装します。
	 *
	 * @return string 'models/transaction/' 配下のモデル名
	 */
	protected function _getHttpRequestParserModelName()
	{
		return 'TransidTransactionModel';
	}
}

/* End of file */