<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @abstract
 */
class MY_Email extends CI_Email 
{
	/**
	 * コンストラクタ
	 */
    function MY_Email($config = array())
    {
        parent::CI_Email($config);
		$this->initialize($config);
    }
	/**
	 * Initialize preferences
	 *
	 * @access	public
	 * @param	array
	 * @return	void
	 */	
	function initialize($config = array())
	{
		$this->set_charset();
		parent::initialize($config);
	}
	/**
	 * Set FROM (日本語対応)
	 *
	 * @access	public
	 * @param	string
	 * @param	string
	 * @return	void
	 */	
	function from($from, $name = '')
	{
		$name = mb_encode_mimeheader($name);
		parent::from($from, $name);
	}
	/**
	 * Set Reply-to (日本語対応)
	 *
	 * @access	public
	 * @param	string
	 * @param	string
	 * @return	void
	 */	
	function reply_to($replyto, $name = '')
	{
		$name = mb_encode_mimeheader($name);
		parent::reply_to($replyto, $name);
	}
	/**
	 * Set Email Subject (日本語対応)
	 *
	 * @access	public
	 * @param	string
	 * @return	void
	 */	
	function subject($subject)
	{
        $subject = mb_encode_mimeheader($subject);
		parent::subject($subject);
	}
	/**
	 * Set Protocol
	 *
	 * @access	public
	 * @param	string
	 * @return	void
	 */	
	function set_charset($charset = 'utf-8')
	{
		//
		if(strtolower($charset) == 'utf-8')
		{
			$config =& get_config();
			//
	        mb_language('uni') ;
	        mb_internal_encoding($config['charset']);
		}
		//
		$this->charset = $charset;
	}
}