<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * @abstract
 */
class MY_Validation extends CI_Validation 
{
	/**
	 * コンストラクタ
	 */
    function MY_Validation()
    {
        parent::CI_Validation();
    }
	/**
	 * Run the Validator
	 *
	 * @access	public
	 * @return	bool
	 */		
	function run()
	{
		// POST が１つも無かった場合の検証されない対策
		if(count($_POST) == 0)
			$_POST[md5(time())] = true;
		// 親
		return parent::run();
	}
	/**
	 * numric less than
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */	
	function numric_lt($str, $val)
	{
		if(!is_numeric($str))
			return false;
		return floatval($str) < $val;
	}
	/**
	 * numric less than equal
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */	
	function numric_le($str, $val)
	{
		if(!is_numeric($str))
			return false;
		return floatval($str) <= $val;
	}
	/**
	 * numric greater than
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */	
	function numric_gt($str, $val)
	{
		if(!is_numeric($str))
			return false;
		return floatval($str) > $val;
	}
	/**
	 * numric greater than equal
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */	
	function numric_ge($str, $val)
	{
		if(!is_numeric($str))
			return false;
		return floatval($str) >= $val;
	}
	/**
	 * numric equal
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */	
	function numric_eq($str, $val)
	{
		if(!is_numeric($str))
			return false;
		return floatval($str) == $val;
	}
	/**
	 * numric not equal
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */	
	function numric_ne($str, $val)
	{
		if(!is_numeric($str))
			return false;
		return floatval($str) != $val;
	}
	/**
	 * 正規表現によるマッチングを行う
	 *
	 * @access	public
	 * @param	string
	 * @return	bool
	 */
	function preg_match($str, $val)
	{
		$srch = array(';', '<', '>');
		$repl = array('|', '[', ']');
		$val = str_replace($srch, $repl, $val);	// TODO2: エスケープを考慮しろ
		return (preg_match($val, $str) > 0);
	}
//	/**
//	 * 
//	 */
//	function defaultvalue($str, $val)
//	{
//		if($str == '')
//			$_POST[$this->_current_field] = $val;
//var_dump($this->_current_field, $str, $val);
//	}
	/**
	 * カード有効期限として妥当かどうかチェックします
	 */
	function card_expire($str)
	{
		// 数値＆桁数チェック
 		if(!is_numeric($str) || strlen($str) != 4)
 			return false;
		// 年月正規化
		$mm = substr($str, 0, 2);
		$yy = '20' . substr($str, 2, 2);	// 4桁に
		// 月チェック
		if($mm < 1 || $mm > 12)
			return false;
		// 年チェック
		$year = date('Y');
		if($yy < $year)
			return false;
		// 年月チェック
		if($yy == $year && $mm < date('n'))
			return false;
		//
		return true;
	}
}