<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/DatabaseTableModelBase.abstract.php');

/**
 * TransactionTrnModel クラス
 */
class TransactionTrnModel extends DatabaseTableModelBase
{
//	/**
//	 *
//	 */
//	const TRN_UNKNOWN			= 0;
//	const TRN_SALE				= 1;
//	const TRN_AUTHORIZATION		= 2;
//	const TRN_DELAYEDCAPTURE	= 3;
//	const TRN_CREDIT			= 4;
//	const TRN_VOID   			= 5;

	/**
	 * テーブル名
	 * @abstract
	 */
	protected $_tablename = 'transaction_trn';

	/**
	 * コンストラクタ
	 */
    public function __construct()
    {
        parent::__construct();
    }

	/**
	 * TransactionTrn テーブルの更新。
	 *
	 * @param string $trnid ＧＷシステムのトランザクションID
	 * @param string $orgtrnid 決済システムのトランザクションID
	 * @param enum $processed 実行済みのトランザクションのステップ
	 * @param string $merchantid MerchantTbl のレコードID
	 * @param string $request リクエストデータ Namevalue 文字列
	 * @return boolean ture。
	 */
	public function writeValue($trnid, $orgtrnid, $processed, $merchantid, $request)
	{
		$datas['trn_id']		= $trnid;
		$datas['orig_trn_id']	= $orgtrnid;
		$datas['merchant_id']	= $merchantid;
		$datas['processed']		= $processed;
		$datas['orig_request_values']	= $request;
		$datas['update_dtm']	= date('Y-m-d H:i:s.u');
		$keys = array('trn_id'/*, 'orig_trn_id'*/);
		// UPDATE
		return $this->replaceArray($datas, $keys);
	}
//	/**
//	 *
//	 */
//	public function updateProcessed($trnid, $processed)
//	{
//		$datas['trn_id']		= $trnid;
//		$datas['processed']		= $processed;
//		$datas['update_dtm']	= date('Y-m-d H:i:s.u');
//		$keys = array('trn_id');
//		// UPDATE
//		return $this->updateArray($datas, $keys);
//	}
	/**
     * ＧＷシステムのトランザクションIDから TransactionTrn テーブルの情報を返す。
     *
     * @param string $trnid ＧＷシステムのトランザクションID
     * @return string 指定IDの TransactionTrn 情報
	 */
	public function getValue($trnid)
	{
		$keys = array(
			'trn_id' => $trnid,
		);
		// SELECT
		$result = $this->getRow($keys);
		//
		return $result;
	}
}

/* End of file */