<?php
require_once(APPPATH.'classes/dataobjects/TransactionSubmitData.class.php');

/**
 * PaypalSubmitData クラス
 */
class PaypalSubmitData extends TransactionSubmitData
{
	/**
	 * 既定メンバーの名前のリスト
	 * ＧＷシステムパラメータ => 決済システムパラメータ
	 */
	protected $_propertynames = array(
		// main
		'USER',
		'VENDOR',
		'PARTNER',
		'PWD',
		'TENDER',
		'TRXTYPE',
		'CRDNUM' =>	'ACCT',
		'CRDEXP' => 'EXPDATE',
		'NAME',
		'AMOUNT' => 'AMT',
		//
		'ORIGID',
		// extra
		'CURRENCY',
		'COMMENT1',
		'COMMENT2',
		'FIRSTNAME',
		'LASTNAME',
		'STREET',
		'CITY',
		'STATE',
		'ZIP',
		'COUNTRY',
		'CVV2',
		'CLIENTIP',
		'VERBOSITY',
	);
	/**
	 * コンストラクタ
	 */
	public function __construct($datas = array())
	{
		parent::__construct($datas);
	}
	/**
	 * http リクエストオブジェクトを解析してメンバーをセットします。
	 *
	 * @param TransactionRequestData $obj http リクエストオブジェクト
	 * @param mixed $options 継承クラス用追加オプション
	 * @return void
	 */
	public function parseRequestObject($obj, $options = null)
	{
		// パラメータをサブミットオブジェクトにセット
		$this->parseArray($obj->toArray(), $this->_propertynames);
		// 専用パラメータ設定
		$this->TENDER	 = 'C';
		$this->VERBOSITY = 'MEDIUM';
	}
}

/* End of file */