<?php
require_once(APPPATH.'classes/dataobjects/TransactionSubmitData.class.php');

/**
 * TransactionSubmitData クラス
 */
class PayvisionSubmitData extends TransactionSubmitData
{
	/**
	 *
	 */
	const MERCHANTACCOUNTTYPE_ECOMMERCE = 1;
	const MERCHANTACCOUNTTYPE_MAILORDER = 2;
	const MERCHANTACCOUNTTYPE_RETAIL = 3;
	const MERCHANTACCOUNTTYPE_RECURRING = 4;

	/**
	 * 既定メンバーの名前のリスト
	 */
	protected $_propertynames = array(
		// must simple
		'AMOUNT'		=> 'amount',
		'CRDNUM'		=> 'cardNumber',
		// must direct
		'ACCOUNT'		=> 'memberId',
		'PASSWORD'		=> 'memberGuid',
		'trackingMemberCode'		=> 'trackingMemberCode',
		'merchantAccountType'		=> 'merchantAccountType',
		// must convert
		'countryId'		=> 'countryId',
		'currencyId'	=> 'currencyId',
		'cardHolder'		=> 'cardHolder',
		'cardExpiryYear'	=> 'cardExpiryYear',
		'cardExpiryMonth'	=> 'cardExpiryMonth',

		// remust convert
		'transactionId'		=> 'transactionId',
		'transactionGuid'	=> 'transactionGuid',

		// may simple
		'CVV2'		=> 'cardCvv',
		'ZIP'		=> 'avsZip',
		// may direct
		'cardType'		=> 'cardType',
		'issueNumber'	=> 'issueNumber',
		// may convert
		'avsAddress'	=> 'avsAddress',
		'dynamicDescriptor'	=> 'dynamicDescriptor',
	);
//		'ORIGID'	=> 'ORIGID',
	/**
	 * コンストラクタ
	 */
	public function __construct($datas = array())
	{
		parent::__construct($datas);
	}
//	/**
//	 *
//	 */
//	public function parseRequestData($reqobj)
//	{
//		// 配列からメンバに設定
//		$this->parseArray($reqobj->toArray());
//		//
//	}
	/**
	 *
	 */
 	public function toString_countryId()
	{
		// 値があればそのまま返す
		if(isset($this->countryId))
			return $this->countryId;
		// ISO 3166 Code maps
		$maps = array(
//			'USD'	=> 840,
//			'EUR'	=> 978,
//			'GBP'	=> 826,
//			'CAD'	=> 124,
//			'AUD'	=> 036,
			'JPN'	=> 392,
		);
		// Request メンバーもなければ null 返す
		if(!array_key_exists($this->COUNTRY, $maps))
			return null;
		// Code → Num 変換して返す
//		$this->countryId = $maps[$this->COUNTRY];
//		return $this->countryId;
		$res = $maps[$this->COUNTRY];
		return $res;
	}
	/**
	 *
	 */
 	public function toString_currencyId()
	{
		// 値があればそのまま返す
		if(isset($this->currencyId))
			return $this->currencyId;
		// ISO 4217 Code maps
		$maps = array(
			'USD'	=> 840,
			'EUR'	=> 978,
			'GBP'	=> 826,
			'CAD'	=> 124,
			'JPY'	=> 392,
			'AUD'	=> 036,
		);
		// Request メンバーもなければ null 返す
		if(!array_key_exists($this->CURRENCY, $maps))
			return null;
		// Code → Num 変換して返す
//		$this->currencyId = $maps[$this->CURRENCY];
//		return $this->currencyId;
		$res = $maps[$this->CURRENCY];
		return $res;
	}
	/**
	 *
	 */
 	public function toString_cardHolder()
	{
		// 値があればそのまま返す
		if(isset($this->cardHolder))
			return $this->cardHolder;
		// Request メンバーから値を構築
		$values = null;
		if(isset($this->FIRSTNAME))
			$values[] = $this->FIRSTNAME;
		if(isset($this->LASTNAME))
			$values[] = $this->LASTNAME;
		// Request メンバーもなければ null 返す
		if(empty($values))
			return null;
		// 文字列合成して返す
//		$this->cardHolder = join(' ', $values);
//		return $this->cardHolder;
		$res = join(' ', $values);
		return $res;
	}
	/**
	 *
	 */
 	public function toString_cardExpiryYear()
	{
		// 値があればそのまま返す
		if(isset($this->cardExpiryYear))
			return $this->cardExpiryYear;
		// Request メンバーもなければ null 返す
		if(!isset($this->CRDEXP))
			return null;
		// 西暦4桁にして設定（validate は済んでる前提）
//		$this->cardExpiryYear = '20' . substr($this->CRDEXP, 2, 2);
//		return $this->cardExpiryYear;
		$res = '20' . substr($this->CRDEXP, 2, 2);
		return $res;
	}
	/**
	 *
	 */
 	public function toString_cardExpiryMonth()
	{
		// 値があればそのまま返す
		if(isset($this->cardExpiryMonth))
			return $this->cardExpiryMonth;
		// Request メンバーもなければ null 返す
		if(!isset($this->CRDEXP))
			return null;
		// 月部分を抽出設定（validate は済んでる前提）
//		$this->cardExpiryMonth = substr($this->CRDEXP, 0, 2);
//		return $this->cardExpiryMonth;
		$res = substr($this->CRDEXP, 0, 2);
		return $res;
	}
	/**
	 *
	 */
 	public function toString_avsAddress()
	{
		// 値があればそのまま返す
		if(isset($this->avsAddress))
			return $this->avsAddress;
		// Request メンバーから値を構築
		$values = null;
		if(isset($this->STREET))
			$values[] = $this->STREET;
		if(isset($this->CITY))
			$values[] = $this->CITY;
		if(isset($this->STATE))
			$values[] = $this->STATE;
		// Request メンバーもなければ null 返す
		if(empty($values))
			return null;
		// 文字列合成して返す
//		$this->avsAddress = join(',', $values);
//		return $this->avsAddress;
		$res = join(',', $values);
		return $res;
	}
	/**
	 *
	 */
 	public function toString_dynamicDescriptor()
	{
		// 値があればそのまま返す
		if(isset($this->dynamicDescriptor))
			return $this->dynamicDescriptor;
		// Request メンバーから値を構築
		$values = null;
		if(isset($this->COMMENT1))
			$values[] = $this->COMMENT1;
		if(isset($this->COMMENT2))
			$values[] = $this->COMMENT2;
		// Request メンバーもなければ null 返す
		if(empty($values))
			return null;
		// 文字列合成して返す
//		$this->dynamicDescriptor = join('|', $values);
//		return $this->dynamicDescriptor;
		$res = join('|', $values);
		return $res;
	}
	/**
	 *
	 */
	public function toString_transactionId()
	{
		// 値があればそのまま返す
		if(isset($this->TransactionId))
			return $this->TransactionId;
		// Request メンバーもなければ null 返す
		if(!isset($this->ORIGID))
			return null;
		// 分割
		@list($id, $guid) = explode(';', $this->ORIGID);
		return $id;
	}
	/**
	 *
	 */
	public function toString_transactionGuid()
	{
		// 値があればそのまま返す
		if(isset($this->TransactionGuid))
			return $this->TransactionGuid;
		// Request メンバーもなければ null 返す
		if(!isset($this->ORIGID))
			return null;
		// 分割
		@list($id, $guid) = explode(';', $this->ORIGID);
		return $guid;
	}
}

/* End of file */