<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once(APPPATH.'classes/ci_extend_libraries/PaymentDriverBase.abstract.php');
require_once('PayvisionSubmitData.class.php');
require_once('PayvisionResponseData.class.php');

/**
 * Payvision.driver クラス
 */
class PayvisionPaymentDriver extends PaymentDriverBase
{
	/**
	 * 
	 */
	protected $_submit_object_name = 'PayvisionSubmitData';
	protected $_response_object_name = 'PayvisionResponseData';
	/**
	 * コンストラクタ
	 */
    public function __construct()
    {
        parent::__construct();
    }

	/**
	 * sale transaction
	 * 
	 * @return bool 成功時は true
	 */
	public function transactionSale($paramobj, $transid = null)
	{
		return $this->_submitPayment('Payment', $paramobj, $transid);
	}
   	/**
     * authorization transaction
     */
    public function transactionAuthorization($paramobj, $transid = null)
	{
		return $this->_submitPayment('Authorize', $paramobj, $transid);
	}
    /**
     * delayed capture transaction
     */
    public function transactionDelayedCapture($paramobj, $transid = null)
	{
		return $this->_submitPayment('Capture', $paramobj, $transid);
	}
	/**
	 * credit transaction
	 */
    public function transactionCredit($paramobj, $transid = null) 
	{
		return $this->_submitPayment('Refund', $paramobj, $transid);
	}
	/**
	 * void transaction
	 */
    public function transactionVoid($paramobj, $transid = null)
	{
		return $this->_submitPayment('Void', $paramobj, $transid);
	}
	/**
     * inquiry transaction
	 */
    public function transactionInquiry($paramobj, $transid = null)
	{
		return $this->_submitPayment('Refund', $paramobj, $transid);
	}
	/**
	 * void or credit transaction
	 */
    public function transactionUnsettled($paramobj, $transid = null)
	{
		$res = $this->transactionVoid($paramobj, $transid);
		return $res;
			









//		// void 可能か確認
//		$dovoid = $this->_isAvailableVoid($paramobj, $transid);
//		$docredit = !$dovoid;
//		// void 実行
//		if($dovoid)
//		{
//			$res = $this->transactionVoid($paramobj, $transid);
//			$obj_res =& $this->getResponseObject();
//			$docredit = ($this->RESULT != 0);	// 失敗したら credit も実行
//		}
//		// credit 実行
//		if($docredit)
//			$res = $this->transactionCredit($paramobj, $transid);
//		// 復帰
//		return $res;
	}
	/**
	 * 
	 */
    public function isAvailableVoid($paramobj, $transid = null)
	{
		return true;
//		$this->transactionInquiry($paramobj, $transid);
//		$obj_res =& $this->getResponseObject();
//		return $obj_res->isAvailableVoid();
	}
	/**
	 * 
	 */
    public function isTransactionSucceed()
	{
		$obj_res =& $this->getResponseObject();
		return $obj_res->isSucceed();
	}
    /**
     * 
     */
    protected function _submitPayment($operation, $paramobj, $transid = null)
    {
//var_dump($operation, $paramobj, $transid);    	
		// サブミット用オブジェクトを取得
		$obj_smt =& $this->getSubmitObject();
		// パラメータをサブミットオブジェクトにセット
		$obj_smt->parseArray($paramobj->toArray());
		// 専用パラメータ設定
		$obj_smt->merchantAccountType = PayvisionSubmitData::MERCHANTACCOUNTTYPE_RECURRING;
		// トランザクションIDをインスタンスに設定（新規の場合は新IDを取得）
		$obj_smt->trackingMemberCode = $this->setTransactionId($transid); 
		// サブミット用オブジェクトからパラメータ文字列の取得 
		$soapparam = $obj_smt->toStringArray(array_values($obj_smt->getPropertyNames()));	// TODO2: ここで array_values はきたない
		// サブミット実行
		$client = new SoapClient($this->_payment_info->SUBMIT_URL);
		$result = $client->$operation($soapparam);
		// レスポンス文字列からレスポンスオブジェクトを初期化＆復帰
		$element = $operation . 'Result';
		$response = $result->$element;
		// インスタンスにサブミット実行情報を保存
		$this->setSubmitValue(print_r($soapparam, true));	// TODO2: print_r ですか！？
		$this->setResponseValue(print_r($response, true));	// TODO2: print_r ですか！？
		// レスポンス用オブジェクトを取得
		$obj_rps =& $this->getResponseObject();
		$obj_rps->parseArray($response);
		//
		return true;
    }
    /**
     * 
     */
    public function initialize($payment)
    {
    	parent::initialize($payment);
    	//
		$obj_smt =& $this->getSubmitObject();
		$obj_smt->memberId		= $payment->ACCOUNT;
		$obj_smt->memberGuid	= $payment->PASSWORD;
    }
}

/* End of file */